/* mfaim
 * Copyright (c) 1999 Josh Myer <josh@joshisanerd.com>
 * console-mode AIM client
 *
 * mfaim is based on naim;
 *  naim is Copyright (c) 1998, 1999 Daniel Reed <n@ml.org>
 * 
 * mfaim also uess libfaim,
 *  FAIM is Copyright 1998 Adam Fritzler <afritz@iname.com>
 *  FAIM uses code Copyright 1998 Brock Wilcox <awwaiid@iname.com>
 */

#include <mfaim.h>

extern WINDOW	*win_status;
extern buddywin_t	*curbwin, nullbwin;
extern int	wsetup_called;

int	printf(const char *format, ...) {
	char	buf[11];
	va_list	msg;
	time_t	t = time(NULL);
	struct tm	*tptr = localtime(&t);

	assert(format != NULL);
	while (*format == '\n')
		format++;
	snprintf(buf, sizeof(buf), "[%02i:%02i:%02i]", tptr->tm_hour,
		tptr->tm_min, tptr->tm_sec);
	if (wsetup_called == 1) {
		wattrset(win_status, COLOR_PAIR(STAT_TEXT));
		waddstr(win_status, buf);
		wattrset(win_status, A_BOLD | COLOR_PAIR(IMWIN_TEXT_U));
		waddstr(win_status, " *** ");
		wattrset(win_status, A_BOLD | COLOR_PAIR(STAT_TEXT));
		va_start(msg, format);
		vwprintw(win_status, format, msg);
		va_end(msg);
		wattrset(win_status, 0);
		nullbwin.waiting = 1;
#if USE_STACK
		sn_queue_enq(nullbwin.winname);
#endif
		wbuddy_update();
	} else if (wsetup_called == 2) {
		va_start(msg, format);
		vwprintw(stdscr, format, msg);
		va_end(msg);
		wrefresh(stdscr);
	} else {
		va_start(msg, format);
		vprintf(format, msg);
		va_end(msg);
	}
	return(1);
}

void	perror(const char *str) {
	if (errno != 0)
		debug_printf("ERROR %i in %s: %s\n", errno, str,
			strerror(errno));
	else
		debug_printf("ERROR in %s\n", str);
#ifdef PERROR_FATAL
	wshutitdown();
	if (errno != 0)
		fprintf(stderr, "error %i: %s: %s\n", errno, str,
			strerror(errno));
	else
		fprintf(stderr, "error *: %s\n", str);
	exit(1);
#else
	if (errno != 0)
		printf("!-! ERROR %i in %s: %s\n", errno, str,
			strerror(errno));
	else
		printf("!-! ERROR in %s\n", str);
#endif
}

